#!/usr/bin/env python
# -*- coding: utf-8 -*- 

"""
Script de suppression des caratères accentués 
"""
import sys
import unicodedata

def un_accentuation(string):
    """permet de supprimer les accents,
    quelque soit le langage
    exemple éèê -> e
    """
    if not type(string) == unicode:
        unicode_string = unicode(string, "utf-8")
    else:
        unicode_string = string
    result = ''.join(unicodedata.normalize('NFD', x)[0] for x in unicode_string)
    # renvoie une string
    return result.encode('utf-8')

def main():
    try:
        content = " ".join(sys.argv[1:])
        content = un_accentuation(content)
        print content
    except:
        print "ce script prend toujours un argument" 
        sys.exit()
        
if __name__ == '__main__':
    main()


