#!/bin/bash
#####################################
# Manage du concentrateur VPN
# Mode Dialog
# Avec ou sans PKI
# MultiTunnel (12/2004)
# LB 01/2003 Eole Dijon
# $Id: reseau-sphynx.sh,v 1.3 2005/01/13 15:53:09 sam Exp $
#######################################
# Initialisation des variables
# Avec verification dans l'Environnement
RepEole=${RepEole="/usr/share/eole"}
RepIpsec=${RepIpsec=/etc/freeswan}
RepSphynx=${RepSphynx=/usr/share/eole/sphynx-vpn}

# Mode Dialog Graphique
ModeDialog=${ModeDialog=oui}
if [ "$ModeDialog" == "oui" ]
then
export DIALOGRC=$RepEole/.dialogrc
export ECHO=InfoBox2
fi
#service gpm status >/dev/null
#if [ $? -ne 0 ]
#then
#	NOMOUSE="--nomouse"
NOMOUSE=""
#fi

TitreGen="Eole  -  Gestion Conf Sphynx"
# Appel Bibliothèque
[ -x $RepEole/FonctionsEole ] || {
        echo "Pas de bibliotheque Eole !"
        exit 1
	}
. $RepEole/FonctionsEole

Question()
{
InputBox "$1" Rep
if [ "$Rep" == "CANCEL" ] 
then
echo "Abandon"	
continue
fi
}
Questions()
{
InputBox "$1" Rep "$3"
if [ "$Rep" == "CANCEL" ] 
then
Zecho "Abandon"	
continue
fi
## On test si le contenu de la reponse n'est pas vide
if [ -n "$Rep" ]
then
	echo "'$2':'$Rep',         " >> $FileCfg
fi
}


#OkBox "Manage Base Sphynx\n\nPour Vous Deplacer sur l'Ecran\nUtiliser votre Souris\nOu la touche tabulation.\n\n   Vous pouvez ABANDONNER \nen pressant la touche <Echap>"
#if [ "$?" -eq 255 ]
#then
	#exit 1
#fi
	
FileCfg="$Tmp/Sphynx$TmpSuff"
TmpFile="$Tmp/Tmp$TmpSuff"
touch $FileCfg
touch $TmpFile


Rep=""
while [ 1 ]
do
MenuBox "Votre Choix"  Rep "1 Gerer_Reseau_Sphynx 2 Regeneration_conf-Sphynx 3 Remplacement_Certif Q Quitter"

if [ "$Rep" == "CANCEL" ] 
then
echo "Abandon"	
exit 1
fi
case $Rep in
	1)
	/usr/share/eole/reseau-sphynx.sh
	;;
	2)
	QuestionBox "Regenerer la configuration ipsec pour Sphynx\n Attention, cette procedure supprime tous les fichiers de /etc/freeswan et les regenere à partir des templates et de la base xml" Rep
	if [ "$Rep" == "OUI" ] 
	then
		rm -f  $RepSphynx/ipsec/*
		rm -f $RepIpsec/ipsec.conf
		rm -f $RepIpsec/ipsec.secret
		rm -f $RepIpsec/ipsec_updown_*
		$RepSphynx/sphynx -t
		cp -f $RepSphynx/ipsec/ipsec.conf_Sphynx $RepIpsec/ipsec.conf
		cp -f $RepSphynx/ipsec/ipsec.secrets_Sphynx $RepIpsec/ipsec.secrets
		cp -f $RepSphynx/ipsec/ipsec_updown_*-sphynx $RepIpsec/
		ls -l $RepIpsec/ > $FileCfg 2>&1
		dialog $NOMOUSE --title "Compte-Rendu "  --exit-label "Quitter" --textbox $FileCfg 0 0
	fi	
	;;
	3)
if [ $vpn_mode != "pki" ]
then
	Zecho "Mode PKI non activé"
	exit 1
fi
Rep=""
if [ -e /etc/freeswan/ipsec.d/certs/sphynx.pem ]
then
	Cn=`openssl x509 -in /etc/freeswan/ipsec.d/certs/sphynx.pem -subject -noout |awk -F "CN=" '{print $2}'`
else
	Cn=""
fi
while [ "$Cn" == "" ]
do
InputBox "Donnez l'identifiant de ce serveur \n(CN du Certificat si mode PKI)" Cn 
if [ "$Cn" == "CANCEL" ] 
then
	exit 1
	Zecho "Abandon"	
else
	Cn=`$RepEole/esc_accents.py $Cn`
fi
done
## MultiSupport
MenuBox "Support des fichiers de config" Rep "/media/floppy Disquette /home/data Disque_Local" #/media/removable USB
if [ "$Rep" == "CANCEL" ]
then
	exit
fi
SupportConf=$Rep
if [ $SupportConf != "/home/data" ]
then
	umount $SupportConf >/dev/null 2>&1
	mount $SupportConf 
	if [ $? -ne 0 ]
	then
		Zecho "Support Non monté : $SupportConf"
		sleep 2
		exit 1
	fi
else
	if [ ! -d "/home/data" ]
	then
		mkdir -p /home/data
	fi
fi
	
## Si support autre que disquette on ouvre un menu permettant de selectionner le repertoire contenant les fichiers de conf
if [ "$SupportConf" != "/media/floppy" ]
then
	Fichier=`dialog $NOMOUSE --backtitle "Selection repertoire contenant fichiers pkcs7 + clef" --title "SELECTION REPERTOIRE" --stdout --fselect $SupportConf 0 0 `
	if [ $? -eq 0 ]
	then
		RepConfIpsec=$Fichier
	else
		exit 1
	fi
else 
	## On initialise RepConfIpsec avec la valeur /media/floppy si on utilise floppy
	RepConfIpsec=$SupportConf
fi
###############

if [ ! -e $RepConfIpsec/$Cn.pkcs7 ] && {
	[ ! -e $RepConfIpsec/certif.pkcs7 ]
}
then
	Zecho "Fichier pkcs7 non trouvé\nAu revoir! "
	exit 1
fi
#echo "Donnez l'identifiant de ce serveur (CN du Certificat)"
#read Cn
if [ ! -e $RepConfIpsec/privkey.pem ]
then
	Zecho "Fichier privkey.pem non trouvé \nAu revoir!"
	exit 1
fi

InfoBox2 "Extraction des Certificats"
if [ -e $RepConfIpsec/$Cn.pkcs7 ]
then
	FicPKCS7="$Cn.pkcs7"
else
	FicPKCS7="certif.pkcs7"
fi
openssl pkcs7 -in $RepConfIpsec/$FicPKCS7 -print_certs | \
/usr/share/eole/ParsePEM.py   -o $RepConfIpsec > /dev/null 2>&1
InfoBox2 "Mise en Place des Certificats"
RepSecret=""
InputBox "Donnez la phrase secrete associée à la clé privée" RepSecret secret
if [ "$RepSecret" == "CANCEL" ] 
then
Zecho "Abandon"	
exit 1
fi
openssl rsa -in $RepConfIpsec/privkey.pem -passin pass:"$RepSecret" -out $RepIpsec/ipsec.d/private/privkey.pem > /dev/null 2>&1
if [ "$?" -ne 0 ]
then
	Zecho "Mauvais Mot de Passe"
	exit 1
fi
cp -f $RepConfIpsec/CertifCa.pem $RepIpsec/ipsec.d/cacerts
cp -f $RepConfIpsec/${Cn}.pem $RepIpsec/ipsec.d/certs/sphynx.pem
## On demonte le support
if [ $SupportConf != "/home/data" ]
then
	umount $SupportConf >/dev/null 2>&1
fi
	;;
	Q)
	exit 0
	;;

esac
done
