#!/bin/bash
############################################
# Initialisation du client VPN
# Avec ou sans PKI
# MultiTunnel (12/2004)
# LB 02/2003 Eole Dijon
############################################
# Initialisation des variables
# Avec verification dans l'Environnement

RepEole=${RepEole="/usr/share/eole"}
RepIpsec=${RepIpsec=/etc/freeswan}
RepSphynx=${RepSphynx=/usr/share/eole/sphynx-vpn}
LgCle=${LgCle=2048}
login=""
passwd=""
TypeAmon="0"
# Mode Dialog Graphique
ModeDialog=${ModeDialog=oui}
if [ "$ModeDialog" == "oui" ]
then
export DIALOGRC=$RepEole/.dialogrc
export ECHO=InfoBox2
fi
#service gpm status >/dev/null
#if [ $? -ne 0 ]
#then
#	NOMOUSE="--nomouse"
NOMOUSE=""
#fi
TitreGen="EOLE  -  Ajout d'un Client RVP"

# Appel Bibliothèque
[ -x $RepEole/FonctionsEole ] || {
        echo "Pas de bibliotheque Eole dans $RepEole!"
        exit 1
	}
. $RepEole/FonctionsEole

### Definition des fonctions ### 

# Fonction Exit
Exit()
{
	Zecho "Abandon"
	exit $1
}

## Recherche du fichier .eol
ParseEol()
{
	if [ -e $ConfigEol ] 
	then
		grep "%%" $ConfigEol >/dev/null && grep "@@" $ConfigEol >/dev/null
		if [ $? == "0" ]
		then
			#echo "Config trouvé"
			eval `grep @@ $ConfigEol | gawk -F '#' '{print $1}' | gawk -F '@'  '{printf("%s=\"%s\"\n",$1 ,$3)}' `
		else
			eval `/usr/share/creole/parsedico.py $ConfigEol`
		fi
	fi
}
ParseConfig()
{
	Fichier=`dialog $NOMOUSE --backtitle "Selection du fichier .eol de l'etablissement" --title "SELECTION FICHIER .eol" --extra-button --extra-label "Passer" --stdout --fselect $SupportConf/config.eol 0 0 `
	if [ $? -eq 0 ]
	then
		ConfigEol=$Fichier
		ParseEol
	else
		exit 1
	fi
}
ParseZephir()
{

	Rep=1
	while [ ! $Rep -eq 0 ]
	do
		Question "Login zephir" "login"
		Question "Mot de passe" "passwd" "secret"
		Question "Identifiant zephir du serveur amon" "NumAmon"
		$RepEole/zephir_get.py $login $passwd $NumAmon
		Rep=$?
	done
	ConfigEol=/home/data/config-$NumAmon.eol
	ParseEol
}

## Menu Questions 
Question()
{
	InputBox "$1" Rep "$3"
	if [ "$Rep" == "CANCEL" ] 
	then
		Exit 1
	elif [ "$Rep" != "" ]
	then
		Rep=`$RepEole/esc_accents.py $Rep`
	fi
	echo "$2 = $Rep" >> $FileCfg
	eval $2=$Rep
}

QuestionBoucle()
{
	Rep="1"
	while [ "$Rep" != "" ]
	do
		Lib="$1 ${Preced=""}"	
		InputBox "$Lib" Rep
		if [ "$Rep" == "CANCEL" ] 
		then
			Exit 1
		fi
		if [ "$Rep" != "" ]
		then
			echo "$2 = $Rep" >> $FileCfg
			Preced="\n  Translation $Rep Active"
		fi
	done
}

## On lit le dico, on pose les questions concernant les paramètres avec choix dico par defaut
Configure()
{
	if [ $ModeZephir -eq 1 ]
	then
		ParseZephir
	else
		ParseConfig	
	fi
	echo "[administration]" > $FileCfg
	echo "id = $Cn " >> $FileCfg
	Question "Nom Etablissement " "nom"
	echo "[technique]" >> $FileCfg
		MenuBox "Type Amon"  Rep "1 amon-2.x 2 amon-1.5"
		if [ "$Rep" == "CANCEL" ]
		then
			echo "Abandon"
			exit 1
		fi
		case $Rep in
			2) echo "version = 1.5 " >> $FileCfg
			;;
			1) echo "version = 2.0 " >> $FileCfg
			;;
		esac
	if [ "$Pki" -eq 0 ] 
	then
		Subject=`openssl x509 -in $SupportConf/${Cn}.pem -subject -noout | awk -F "subject= " '{print $2}'`
		echo "passerelle = $Subject" >> $FileCfg
	else
		 Question "Index passerelle \n(CN etablissement ou Nom DNS Amon)" "passerelle" "$Cn"
	fi
	 
	QuestionBox "L'amon est il en adressage privée ? oui/non" Rep
       	if [ "$Rep" == "OUI" ]
	then
		Question "Adresse IP privée du serveur Amon" "ip_priv_amon" "$adresse_ip_eth0"
		Question "Adresse IP privée du routeur" "ip_priv_routeur" "$adresse_ip_gw"
		Question "Adresse IP publique du routeur" "ip_externe" 
		echo "ip_routeur = %defaultroute" >> $FileCfg
	else
		Question "Adresse IP externe du serveur Amon" "ip_externe" "$adresse_ip_eth0"
		Question "Adresse IP routeur " "ip_routeur" "$adresse_ip_gw"
	fi
	Question "Adresse Reseau Entrant dans le Tunnel " "adresse_sous_reseau" "$adresse_network_eth1"
	Question "Masque Reseau Entrant dans le Tunnel " "masque" "$adresse_netmask_eth1"
	Question "Adresse de translation du PareFeu\n dans le reseau \
        	  $adresse_sous_reseau/$masque" "nat" "$adresse_ip_eth1"
	QuestionBoucle "Translation dans le Tunnel\nRien Pour Terminer\n \
		Donnez La Source:Destination\n \
		Destination dans $adresse_sous_reseau/$masque\n \
		Exemple:\nUne station 172.16.1.45:172.16.0.50\n \
		\nTout un réseau 172.16.1.0/24:172.16.0.50\n" \
		"translation"
		
	dialog $NOMOUSE --title "Touche <ESC> pour annuler"  --exit-label "Accepter" --textbox $FileCfg 0 0
	if [ "$?" -eq 255 ]
	then
		Zecho "Abandon"
		exit 1
	fi
}

# Fonction Copie des fichiers de Conf sur le support
CopieFic () {
	RepCour=`pwd`
	cd $RepSphynx/ipsec
	ListeFic=`ls -c1 *$Cn`
	for Fic in $ListeFic
	do	
		cp -f $Fic $SupportConf 
		if [ $? -ne 0 ]
		then
			Zecho "Problème $SupportConf"
			exit 1
		fi
	done
	ListeFic=`ls -c1 ipsec_updown_*$Cn-[0-9]*`
	for Fic in $ListeFic
	do	
		cp -f $Fic $SupportConf 
		if [ $? -ne 0 ]
		then
			Zecho "Problème $SupportConf"
			exit 1
		fi
	done
	cd $RepCour
}

# Fonction d'envoi des fichiers à zephir
EnvoiZephir () {
	cd $SupportConf
	/bin/tar czf /home/data/vpn_$Cn.tar * &> /dev/null

	if [ "$passwd" == "" ]
	then
		Rep=1
		while [ ! $Rep -eq 0 ]
		do
			Question "Login zephir" "login"
			Question "Mot de passe" "passwd" "secret"
			Question "Identifiant zephir du serveur amon" "NumAmon"
			$RepEole/zephir_send.py $login $passwd $NumAmon /home/data/vpn_$Cn.tar
			Rep=$?
		done
	else
		$RepEole/zephir_send.py $login $passwd $NumAmon /home/data/vpn_$Cn.tar
	fi
	if [ ! $? -eq 0 ]
	then
		Zecho "Problème lors de l'envoi à zephir"
		exit 1
	fi
	rm -f $SupportConf/vpn_$Cn.tar
	cd $RepCour
}

# Generation des fichiers pour l'Amon
# Procedure commune pour mode PKI et CLEF
GenFichiers()
{
	#if [ "TypeAmon" == "0" ]
	#then
	TypeAmon=`$RepSphynx/tunnel/tunnel --etab-get-version $Cn`
	#fi
	Zecho "Création des fichiers de configuration "
	if [ "$TypeAmon" == "2.0" ]
	then
		$RepSphynx/sphynx -z $Cn
	elif [ "$TypeAmon" == "1.5" ]
	then
		$RepSphynx/sphynx -g $Cn
	else
		MenuBox "Type Amon"  Rep "1 amon-1.5 2 amon-2.x"
		if [ "$Rep" == "CANCEL" ]
		then
			echo "Abandon"
			exit 1
		fi
		case $Rep in
			1) $RepSphynx/sphynx -g $Cn
			$RepSphynx/tunnel/add_amon_type $Cn "1.5"
			;;
			2) $RepSphynx/sphynx -z $Cn
			$RepSphynx/tunnel/add_amon_type $Cn "2.0"
			;;
		esac

	fi
	. ParseDico
	if [ $haute_dispo == "non" ]
	then
		adresse_ip_sphynx=$adresse_ip_eth1
	else
		adresse_ip_sphynx=$adresse_ip_redondee_eth1
	fi
if [ "$TypeAmon" == "2.0" ]
then
####### Creation fichiers test-rvp et Id##########
	cat > $SupportConf/test-rvp <<Eof
#!/bin/bash
# DEB:$Cn
echo -n "Réseau Virtuel Privé :"
if [  -e /var/lock/rvp ]
then
	fping $adresse_ip_sphynx
else
	echo "Le tunnel n'est pas actif!"
	exit 2
fi
# FIN:$Cn
Eof
	echo "$Cn" > $SupportConf/Id
####### Fin creation fichier ###########
elif [ "$TypeAmon" == "1.5" ]
then
####### Creation fichiers test-rvp et Id##########
	cat > $SupportConf/test-rvp <<Eof
#!/bin/bash
# DEB:$Cn
echo -n "Reseau Virtuel Prive :"
if [  -e /var/lock/subsys/rvp ]
then
	fping $adresse_ip_sphynx
else
	echo "Le tunnel n'est pas actif!"
	exit 2
fi
# FIN:$Cn
Eof
	echo "$Cn" > $SupportConf/Id
####### Fin creation fichier ###########
fi

	Zecho "Copie des fichiers Etablissements sur le support"
	CopieFic
	if [ $ModeZephir -eq 1 ]
	then
		EnvoiZephir
		Zecho "Envoi des fichiers Etablissements à zephir"
	fi
	
	
	Zecho " Etablissement $Cn créé"

	## On test si il s'agit de la première initialisation
	grep "#DEB" /etc/freeswan/ipsec.conf >/dev/null
	if [ $? -eq 1 ]
	then
		Sphynx="Nouv"
	fi
	# Mise en place des nouveaux fichiers de conf sur le concentrateur
	Zecho "Mises à jours du concentrateur"
	cp -f $RepSphynx/ipsec/ipsec.conf_Sphynx $RepIpsec/ipsec.conf
	cp -f $RepSphynx/ipsec/ipsec.secrets_Sphynx $RepIpsec/ipsec.secrets
	#cp -f $RepSphynx/ipsec/ipsec_updown_$Cn-sphynx $RepIpsec/
	## Plus utilisé dans le version MultiTunnels
	# ajout des regles pour le firewall
	#Zecho "Génération du sphynx firewall"
	#$RepEole/sphynx-bastion/bin/sphynx-bastion.sh

	Zecho "Client Vpn $Cn Initialisé "
	Liste=` $RepSphynx/tunnel/tunnel --etab-connexion-list $Cn| awk '{print $1}'` 
	if [ "$Sphynx" == "Nouv" ]
	then 
		/etc/init.d/ipsec stop
		/etc/init.d/ipsec start
	else
		for Connex in $Liste
		do
			grep "C-${Connex}-sphynx" $RepIpsec/ipsec.conf >/dev/null
			if [ $? == 0 ]
			then 
				/usr/sbin/ipsec auto --delete C-${Connex}-sphynx >/dev/null 2>&1
				/usr/sbin/ipsec auto --add C-${Connex}-sphynx >/dev/null 2>&1

			else
			/usr/sbin/ipsec auto --add C-${Connex}-sphynx >/dev/null 2>&1
			fi
			sleep 1
		done
		#/sbin/lsmod |grep "ipsec_aes" |grep "ipsec_sha2" >/dev/null
		#if [ "$?" -ne "0" ]
		#then
		#	/sbin/modprobe ipsec_aes >/dev/null 2>&1
		#	/sbin/modprobe ipsec_sha2 >/dev/null 2>&1
		#fi
	fi
	if [ "$SupportConf" != "/home/data" ]
	then
		umount $SupportConf >/dev/null 2>&1
	fi
}


# MAIN


Zecho "Initialisation d'un client Vpn -AMON-"
if [ ! -e $RepSphynx/xml/sphynx.xml ]
then
	Zecho "La base xml n'a pas  été initialisée\nAbandon de la configuration"
	exit 1
fi

FileCfg="$Tmp/Sphynx$TmpSuff"
TmpFile="$Tmp/Tmp$TmpSuff"
touch $FileCfg
touch $TmpFile

#OkBox "Ajout d'un Client dans la Base Sphynx\n\nPour Vous Deplacer sur l'Ecran\nUtiliser votre Souris\nOu la touche tabulation.\n\n   Vous pouvez ABANDONNER \nen pressant la touche <Echap>"
#if [ $? -eq 255 ]
#then
#	Exit 1
#fi

## Menu selection support
python -c "from zephir.zephir_conf.zephir_conf import id_serveur" >/dev/null 2&>1
if [ $? -eq 0 ]
then
        MenuBox "Support des fichiers de config" Rep "/media/floppy Disquette /home/data Disque_Local zephir zephir" #/media/removable USB
else
        MenuBox "Support des fichiers de config" Rep "/media/floppy Disquette /home/data Disque_Local" #/media/removable USB
fi

if [ "$Rep" == "CANCEL" ]
then
	exit
fi

ModeZephir=0
if [ "$Rep" == "zephir" ]
then
	SupportConf="/home/data"
	ModeZephir=1
else
	SupportConf=$Rep
fi

## Montage des supports si != de repertoire local
if [ $SupportConf != "/home/data" ]
then
	umount $SupportConf >/dev/null 2>&1
	mount $SupportConf 
	if [ $? -ne 0 ]
	then
		Zecho "Support Non monté : $SupportConf"
		sleep 2
		exit 1
	fi
else
	## Si repertoire data n'existe pas, on le creer
	if [ ! -d "/home/data" ]
	then
		mkdir -p /home/data
	fi
fi
	
## Identifiant Etab
Cn=""
while [ "$Cn" == "" ]
do
	InputBox "Donnez l'identifiant du Serveur Amon \n(CN du Certificat si mode PKI)" Cn 
	if [ $Cn == "CANCEL" ] 
	then
		Exit 1
	else
		Cn=`$RepEole/esc_accents.py $Cn`
	fi
	## si support = disquette on ne creer pas de repertoire $Cn 
	if [ "$SupportConf" != "/media/floppy" ]
	then
		SupportConf=$SupportConf"/"$Cn
	fi

	##### GENERATION FICHIER CONF #####
	# TODO Attention au grep il faut être precis
	Existe=`grep -q "id=\"$Cn\""  $RepSphynx/xml/sphynx.xml; echo $?`
	## Fonction permettant de regenerer la conf d'un etab 
	if [ "$1" == "GenConf" ]
	then
		# Uniquement génération des fichiers de conf
                if [ $Existe -eq 0 ]
		then
			if [ ! -d $SupportConf ]
			then
				mkdir $SupportConf
			fi
			GenFichiers
			sleep 2
			exit
		else
			Zecho "$Cn non trouvée"
			sleep 2
			exit 
		fi
	fi
	if [ $Existe -eq 0 ]
	then
		Rep=""
		QuestionBox "$Cn existe\n Voulez vous l'effacer?" "Rep"
		if [ "$Rep" == "OUI" ]
		then
			${RepSphynx}/sphynx -s $Cn > $TmpFile 2>&1 
			if [ "$?" -ne 0 ]
			then
				OkBox "`cat $TmpFile`"
				Exit 1
			else
				Zecho "Effacement $Cn"
				rm -f /usr/share/eole/sphynx-vpn/ipsec/ipsec_updown_*$Cn-[0-9]*
				sleep 2
		        fi
		else
			Cn=""
		fi
	fi
done

if [ ! -d $SupportConf ]
then
	mkdir $SupportConf
fi

## Mode PKI
Rep=""
grep -q "mode = pki" /usr/share/eole/sphynx-vpn/cfg/sphynx.cfg 
Pki=$?
if [ $Pki -eq 0 ]
then
	Zecho "Mode PKI activé"
	OkBox "Inserez le support contenant le fichier pkcs7 \net la clée privée"
	if [ $? -eq 255 ]
	then
		Exit 1
	fi
	## fenetre selection repertoire contenant le pkcs7 et la clef privee
	pkcs=`dialog $NOMOUSE --backtitle "Selection repertoire contenant fichiers pkcs7 + clef" --title "SELECTION REPERTOIRE" --stdout --fselect $SupportConf 0 0 `
	if [ $? -eq 0 ]
	then
		#PKCS=$pkcs/$Cn.pkcs7
		RepConfIpsec=$pkcs
	else
		exit 1
	fi

	#if [ ! -e $PKCS ]
	#then
	#	Zecho "$PKSC: Fichier  non trouvé "
	#	exit 1
	#fi
	if [ ! -e $RepConfIpsec/$Cn.pkcs7 ] && {
		        [ ! -e $RepConfIpsec/certif.pkcs7 ]
	}
	then
		Zecho "Fichier pkcs7 non trouvé\nAu revoir! "
		exit 1
	fi
			
	# Procedure d'extraction des certifs pkcs7 -> x509
	Zecho "Extraction des Certificats"
	if [ -e $RepConfIpsec/$Cn.pkcs7 ]
	then
		FicPKCS7="$Cn.pkcs7"
	else
	        FicPKCS7="certif.pkcs7"
	fi
			
	openssl pkcs7 -in $RepConfIpsec/$FicPKCS7 -print_certs | \
	/usr/share/eole/ParsePEM.py   -o $SupportConf >/dev/null 2>&1
	if [ $? -ne 0 ]
	then
		Zecho "Problème d'extraction du certificat"
		exit 1
	fi
	if [ ! -e $SupportConf/${Cn}.pem ]
	then
		Zecho "Fichier ${Cn}.pem non trouvé "
		exit 1
	fi
	Zecho "Initialisation Mode PKI terminée"

	# Ajout dans la Base XML
	Configure
        Zecho "Ajout de l'etablissement dans la Base"
	> $TmpFile

	$RepSphynx/sphynx -a  -f $FileCfg -n $Cn -c $SupportConf/${Cn}.pem >$TmpFile 2>&1
	# Sphynx ne sait pas retourner un code Erreur !!! :-{
	Existe=`grep -q "id=\"$Cn\""  $RepSphynx/xml/sphynx.xml; echo $?`
	if [ $Existe -ne 0 ]
	then
		OkBox "`cat $TmpFile`"
		Zecho "Etablissement Non Ajouté"
		exit 1
	fi
	# Script de récupération de le liste de révocation
	if [ "$TypeAmon" == "1.5" ]
	then
		. ParseDico
		url_crl1=$url_crl1
###### Creation Fichier Recup-Crl.sh #######
		cat > $SupportConf/Recup-Crl.sh <<Eof
#!/bin/bash
#----------------------------
# Recupération 
# des listes de revocations
# Amon 1.5
# LB Eole 02/2003
#----------------------------
# Appel Bibliothèque
[ -x /usr/share/eole/FonctionsEole ] || {
	echo "Pas de bibliotheque Eole !"
	exit 1
}
. /usr/share/eole/FonctionsEole

 ParseDico

VERSION=`cat /etc/eole/version`

rc=0
Zephir "INIT" "MAJ liste revocation"
[ "\$rc"  -ne '0' ] && {
                Zecho "Probleme Zephir"
		Zecho "RC = $rc"
		Zecho "Contacter l'administrateur"
		exit
	}
RepCour=`pwd`
date >/tmp/RecupCrl.log 
cd /etc/freeswan/ipsec.d/crls
# DEB:$Cn
wget --timestamping ${url_crl1} >> /tmp/RecupCrl.log 2>&1
# FIN:$Cn
/usr/sbin/ipsec auto --rereadcrls
cd $RepCour
Zephir "FIN" "MAJ liste revocation"
Eof
###### Fin Creation Fichier Recup-Crl.sh #######
	fi
	Zecho "Etablissement Ajouté"

	else # FIN Mode PKI	
	
	## Mode clef
	Zecho "Mode CLEF activé"
	sleep 1
	Configure
	Zecho "Génération des clefs et ajout dans la Base"
		$RepSphynx/sphynx -a -n $Cn -f $FileCfg  -k $LgCle >$TmpFile 2>&1
	# Sphynx ne sait pas retourner un code Erreur !!! :-(
	Existe=`grep -q "id=\"$Cn\""  $RepSphynx/xml/sphynx.xml; echo $?`
	if [ $Existe -ne 0 ]
	then
		OkBox "`cat $TmpFile`"
		Zecho "Etablissement Non Ajouté"
		exit 1
	fi
	Zecho "Etablissement Ajouté"
fi 

## Generation des fichiers
GenFichiers
. ParseDico
if [ $haute_dispo != "non" ]
then
	/usr/share/eole/synchro-sphynx.sh
fi
	

exit

