#!/bin/bash
###############################################
# Génération de la demande de certificat
# - Enrole PKI PKCS#10  avec openssl
# Version Beta
# LB 12/2002 Eole Dijon
# $Id: init-certif.sh,v 1.3 2005/01/13 15:53:09 sam Exp $
##############################################
# Initialisation des variables
# Avec verification dans l'Environnement
RepEole=${RepEole="/usr/share/eole"}
RepIpsec=${RepIpsec=/etc/freeswan}
RepSphynx=${RepSphynx=/usr/share/eole/sphynx-vpn}
LgCle=${LgCle=2048}
PKI=0
Rep=""

# Mode Dialog Graphique
ModeDialog=${ModeDialog=oui}
if [ "$ModeDialog" == "oui" ]
then
export DIALOGRC=$RepEole/.dialogrc
export ECHO=InfoBox2
fi
#service gpm status >/dev/null
#if [ $? -ne 0 ]
#then
#	NOMOUSE="--nomouse"
	NOMOUSE=""
#fi

TitreGen="Eole  -  DEMANDE DE CERTIFICAT"
# Appel Bibliothèque
[ -x $RepEole/FonctionsEole ] || {
        echo "Pas de bibliotheque Eole !"
        exit 1
	}
. $RepEole/FonctionsEole

Question()
{
InputBox "$1" Rep
if [ "$Rep" == "CANCEL" ] 
then
echo "Abandon"	
exit 1
fi
}


################
REQUETEOUT=$SupportConf/requete.p10
REQUETECONF=${CONFENROLE:-/usr/share/eole/requete-eole.conf}
if [ ! -e $REQUETECONF ]
then
	echo "Fichier de configuration $REQUETECONF pas trouvé"
	exit 1

fi
MenuBox "Support des fichiers de config" Rep "/media/floppy Disquette  /home/data Disque_Local" #/media/removable USB
if [ "$Rep" == "CANCEL" ]
then
	exit
fi
SupportConf=$Rep
if [ $SupportConf != "/home/data" ]
then
	OkBox "inserez la Disquette\n <ESC> pour Abandon" 
	if [ "$?" -eq 255 ]
	then
		exit 1
	fi
	umount $SupportConf >/dev/null 2>&1
	mount $SupportConf 
	if [ $? -ne 0 ]
	then
		Zecho "Support Non monté : $SupportConf"
		sleep 2
		exit 1
	fi
else
	if [ ! -d "/home/data" ]
	then
		mkdir -p /home/data
	fi
fi
	
###
	
Question "Identifiant du Serveur (CN)"
CN=$Rep
## si support = disquette on ne creer pas de repertoire $Cn 
if [ "$SupportConf" != "/media/floppy" ]
then
	SupportConf=$SupportConf"/"$CN
	if [ ! -d $SupportConf ]
	then
		mkdir -p $SupportConf
	fi
fi
REQUETEOUT=$SupportConf"/"$CN.p10
if [ -e $REQUETEOUT ]
then
	QuestionBox "Attention:\nune requete pou $CN existe dèja.\nVoulez la suprimer? " Rep
	if [ "$Rep" == "OUI" ]
	then
		rm -f $REQUETEOUT
	else
        exit 1
        fi
fi
ConfReq=/tmp/ConfReq$$
cat $REQUETECONF | sed -e "s/CN-SERVEUR/$CN/" > $ConfReq
Rep=""
Question "Commentaire souhaité pour le certificat $CN\nEntrez le nom DNS du serveur par exemple :"
echo "SubjectAltName=$Rep" > $REQUETEOUT
openssl req -new -newkey rsa:$LgCle -config $ConfReq -keyout $SupportConf/privkey.pem -out $REQUETEOUT.tmp && cat $REQUETEOUT.tmp >> $REQUETEOUT


rm $ConfReq
rm $REQUETEOUT.tmp

VarText=$(ls -l $SupportConf 2>&1)
sleep 3
OkBox "$VarText"
#umount /media/floppy > /dev/null 2>&1
