#!/bin/bash
#######################################
# Initialisation du concentrateur VPN
# Mode Dialog
# Avec ou sans PKI
# PreVersion 2
# LB 01/2003 Eole Dijon
# $Id: init-sphynx.sh,v 1.5 2005/03/31 12:33:29 sam Exp $
########################################
# Initialisation des variables
# Avec verification dans l'Environnement
RepEole=${RepEole="/usr/share/eole"}
RepIpsec=${RepIpsec=/etc/freeswan}
RepSphynx=${RepSphynx=/usr/share/eole/sphynx-vpn}
LgCle=${LgCle=2048}
PKI=0
# Mode Dialog Graphique
ModeDialog=${ModeDialog=oui}
if [ "$ModeDialog" == "oui" ]
then
export DIALOGRC=$RepEole/.dialogrc
export ECHO=InfoBox2
fi
#telinit run gpm status >/dev/null
#if [ $? -ne 0 ]
#then
#	NOMOUSE="--nomouse"
	NOMOUSE=""
#fi
TitreGen="Eole  -   Initialisation du Sphynx"
# Appel Bibliothèque
#[ -x /usr/share/eole/FonctionsEole ] || {
[ -x $RepEole/FonctionsEole ] || {
        echo "Pas de bibliotheque Eole !"
        exit 1
	}
. $RepEole/FonctionsEole
. ParseDico

CRL1=$url_crl1
CRL2=$url_crl2

Question()
{
	InputBox "$1" Rep "$3"
	if [ "$Rep" == "CANCEL" ] 
	then
		Zecho "Abandon"	
		exit 1
	fi
	echo "$2 = $Rep" >> $FileCfg
}



OkBox "Initialisation Base Sphynx\n\nPour Vous Deplacer sur l'Ecran\nUtiliser votre Souris\nOu la touche tabulation.\n\n   Vous pouvez ABANDONNER \nen pressant la touche <Echap>"
if [ "$?" -eq 255 ]
then
	exit 1
fi
	
FileCfg="$Tmp/Sphynx$TmpSuff"
touch $FileCfg

Zecho "Initialisation SPHYNX"
sleep 1

if [ -e $RepSphynx/xml/sphynx.xml ]
then
	OkBox "La base à dèja été initialisée\nConfirmez l'effacement\n Ou <ESC> pour Abandonner" 
	Rep=$?
	if [ "$Rep" -eq 0 ]
	then
		Zecho "Fichier de configuration effacé"
                cp  -f $RepSphynx/xml/sphynx.xml $RepSphynx/xml/sphynx.xml.sav 
		rm -f $RepSphynx/xml/sphynx.xml
	else
		Zecho "Abandon de la configuration"
		exit 1
	fi
fi
Rep=""
Cn=""
while [ "$Cn" == "" ]
do
InputBox "Donnez l'identifiant de ce serveur \n(CN du Certificat si mode PKI)" Cn 
if [ "$Cn" == "CANCEL" ] 
then
	exit 1
	Zecho "Abandon"	
else
	Cn=`$RepEole/esc_accents.py $Cn`
fi
done
Rep=""
#MenuBox "Mode VPN ?"  Rep "Pki Avec_Certficats Clef Sans_Certificat"

#if [ "$Rep" == "CANCEL" ] 
#then
#Zecho "Abandon"	
#exit 1
#fi

#if [ "$Rep" == "Pki" ]
if [ $vpn_mode == "pki" ]
then
	Zecho "Mode PKI activé"
	PKI=1
## MultiSupport
MenuBox "Support des fichiers de config" Rep "/media/floppy Disquette /home/data Disque_Local" #/media/removable USB
if [ "$Rep" == "CANCEL" ]
then
	exit
fi
SupportConf=$Rep
if [ $SupportConf != "/home/data" ]
then
	umount $SupportConf >/dev/null 2>&1
	mount $SupportConf 
	if [ $? -ne 0 ]
	then
		Zecho "Support Non monté : $SupportConf"
		sleep 2
		exit 1
	fi
else
	if [ ! -d "/home/data" ]
	then
		mkdir -p /home/data
	fi
fi
	
## Si support autre que disquette on ouvre un menu permettant de selectionner le repertoire contenant les fichiers de conf
if [ "$SupportConf" != "/media/floppy" ]
then
	Fichier=`dialog $NOMOUSE --backtitle "Selection repertoire contenant fichiers pkcs7 + clef" --title "SELECTION REPERTOIRE" --stdout --fselect $SupportConf 0 0 `
	if [ $? -eq 0 ]
	then
		RepConfIpsec=$Fichier
	else
		exit 1
	fi
else 
	## On initialise RepConfIpsec avec la valeur /media/floppy si on utilise floppy
	RepConfIpsec=$SupportConf
fi
###############

#	OkBox "Inserez la disquette contenant le fichier pkcs7 \net la clée privée"
#	umount /media/floppy >/dev/null 2>&1
#	mount /media/floppy >/dev/null 2>&1
#	if [ "$?" -ne 0 ]
#	then
#		Zecho "Problème disquette...\nAu revoir!"
#		exit 1
#	fi

if [ ! -e $RepConfIpsec/$Cn.pkcs7 ] && {
	[ ! -e $RepConfIpsec/certif.pkcs7 ]
}
then
	Zecho "Fichier pkcs7 non trouvé\nAu revoir! "
	exit 1
fi
#echo "Donnez l'identifiant de ce serveur (CN du Certificat)"
#read Cn
if [ ! -e $RepConfIpsec/privkey.pem ]
then
	Zecho "Fichier privkey.pem non trouvé \nAu revoir!"
	exit 1
fi

InfoBox2 "Extraction des Certificats"
if [ -e $RepConfIpsec/$Cn.pkcs7 ]
then
	FicPKCS7="$Cn.pkcs7"
else
	FicPKCS7="certif.pkcs7"
fi
openssl pkcs7 -in $RepConfIpsec/$FicPKCS7 -print_certs | \
/usr/share/eole/ParsePEM.py   -o $RepConfIpsec > /dev/null 2>&1
InfoBox2 "Mise en Place des Certificats"
RepSecret=""
InputBox "Donnez la phrase secrete associée à la clé privée" RepSecret secret
if [ "$RepSecret" == "CANCEL" ] 
then
Zecho "Abandon"	
exit 1
fi
openssl rsa -in $RepConfIpsec/privkey.pem -passin pass:"$RepSecret" -out $RepIpsec/ipsec.d/private/privkey.pem > /dev/null 2>&1
if [ "$?" -ne 0 ]
then
	Zecho "Mauvais Mot de Passe"
	exit 1
fi
cp -f $RepConfIpsec/CertifCa.pem $RepIpsec/ipsec.d/cacerts
cp -f $RepConfIpsec/${Cn}.pem $RepIpsec/ipsec.d/certs/sphynx.pem
## On demonte le support
if [ $SupportConf != "/home/data" ]
then
	umount $SupportConf >/dev/null 2>&1
fi
Zecho "Initialisation Mode PKI terminée"
fi # Mode PKI	

# Creation Base XML
Zecho "Création de la base de configuration Freeswan"
echo "[technique]" > $FileCfg
if [ "$PKI" -eq  1 ]
then
Opt="-c $RepIpsec/ipsec.d/certs/sphynx.pem "
Subject=`openssl x509 -in $RepIpsec/ipsec.d/certs/sphynx.pem  -subject -noout | awk -F "subject= " '{print $2}'`
echo "passerelle = $Subject" >> $FileCfg
else
	Opt="-k $LgCle"
        Question "Nom DNS du serveur SPHYNX" "passerelle" $nom_machine.$nom_domaine_local
fi
Question "IP Externe de votre Serveur" "ip_externe" "$adresse_ip_eth0"
if [ $haute_dispo != "non" ]
then
Question "IP Externe redondee de votre Serveur" "ip_redondee" "$adresse_ip_redondee_eth0"
fi	
Question "IP de votre Routeur Internet" "ip_routeur" "$adresse_ip_gw"
Question "Adresse Reseau Concentration" "adresse_sous_reseau" "$adresse_network_eth1"
Question "Masque Reseau Concentration " "masque" "$adresse_netmask_eth1"
if [ $vpn_mode == "pki" ]
then
	if [ "$CRL1" != "" ]
	then
		echo "url_crl1 = $CRL1" >> $FileCfg
		fi
	if [ "$CRL2" != "" ]
	then
		echo "url_crl2 = $CRL2" >> $FileCfg
	fi
fi
Rep=""
dialog --title "Touche <ESC> pour annuler"  --exit-label "Accepter" --textbox $FileCfg 0 0
if [ "$?" -eq 255 ]
then
        Zecho "Abandon"
        exit 1
fi

# suppression des accents pour éviter les pb d'encoding
eval $RepEole/esc_accents.py $FileCfg

eval $RepSphynx/sphynx -i -f $FileCfg -n $Cn $Opt
Zecho "Création de la base terminée"
# telechargement des crls si mode pki
#if [ "$PKI" -eq  1 ]
#then
#	Zecho "Recuperation des listes de revocation"
#	/usr/share/eole/Recup-Crl.sh
#fi
. ParseDico
if [ $haute_dispo != "non" ]
then
	/usr/share/eole/synchro-sphynx.sh
fi

