package IpsecSecretSphynx ;
#
use strict ;
#
#    Conception :
#    Eole (http://eole.orion.education.fr)

#    Copyright (C) 2002

#    Ce code a t dvelopp par
#    Gwenal Rmond (gwenael.remond@free.fr)
#    Samuel Morin (samuel.morin@ac-dijon.fr)

#    distribu sous la licence GPL-2 

#    Version $Revision: 1.1.1.1 $

#    En attendant une traduction officielle de la GPL, la notice de 
#    copyright demeure en anglais.

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#    $Id: IpsecSecretSphynx.pm,v 1.1.1.1 2004/02/09 12:41:49 gwen Exp $
#    $Source: /home/cvs/sphynx/sphynx-vpn/perl/IpsecSecretSphynx.pm,v $


#    Se reporter  la documentation envoye avec le programme pour la notice.
#    Si elle manquait, envoyer un email  Gwenal Rmond (gwenael.remond@free.fr)
#    Samuel Morin (samuel.morin@ac-dijon.fr)





=pod

=head1 NOM



IpsecSecretSphynx



=cut




=pod

=head1 DESCRIPTION



Utilitaire XPath permettant de rcuprer la clef RSA d'un tablissement suivant son identifiant.



=cut




=pod

=head1 SYNOPSIS



use IpsecSecretSphynx ;
IpsecSecretSphynx::clef(
		  'xml' => "fichier.xml"
		  , 'fichier' => "destination.txt"
		  , 'id' => "num_identifiant"
		  , 'balise'=> 'etablissement' ou bien 'academie'
		  ) ;



=cut




=pod

=head1 PREREQUIS



=pod

=over 

=cut



=pod

=item I<XML::LibXML>

=cut

use XML::LibXML ;



=pod

=back



=cut




=pod

=head1 VARIABLES GLOBALES




=cut



=pod

=over 

=cut





=pod

=back

=cut




=pod

=head1 VARIABLES LOCALES




=cut



=pod

=over 

=cut




=pod

=item I<$xp>

requte XPath

=cut

my $xp ;



=pod

=item I<$clef>

rsultat de la requte

=cut

my $clef ;



=pod

=item I<$machine>

rsultat de la requte xpath

=cut

my $machine ;



=pod

=item I<$expression>

expression XPath

=cut

my $expression ;



=pod

=item I<$path_machine>

expression XPath

=cut

my $path_machine ;




=pod

=back

=cut


=pod

=head1 FONCTIONS




=cut



=pod

=over 

=cut




=pod

=item I<recup_clef>

fonction permettant de rcuprer la clef RSA

=cut

sub recup_clef
{


my %params = @_ ;

# objet dom

$xp = XML::LibXML->new() ;
my $file = $params{ 'xml' } ;
my $tree = $xp->parse_file( $file ) ;

# rcupration de la clef et formatage de l'expression XPath

if ( $params{ 'balise' } eq 'etablissement' )
{

$expression = "sphynx/etablissement[\@id=\'".$params{ 'id' }."\']/clef-rsa/text()" ;
$path_machine = "sphynx/etablissement[\@id=\'".$params{ 'id' }."\']/\@machine" ;

} else  {

$expression = "sphynx/academie/clef-rsa/text()" ;
$path_machine = "sphynx/\@nom" ;
}


$clef = $tree->findvalue( $expression ) ;
$machine = $tree->findvalue ( $path_machine ) ;

# $clef = Unicode::String::utf8( $clef )->latin1() ;

# effacement des espaces et des retour chariot
# $clef =~ s/ //g ;
# $clef =~ s/\n//g ;

return ( $clef, $machine ) ;



}

=pod

=item I<clef>

rcupre et enregistre la clef dans un fichier

=cut

sub clef
{



my %params = @_ ;

my ( $rsa , $machine ) = IpsecSecret::recup_clef(
                    'xml' => $params{ 'xml' }
		  , 'id' => $params{ 'id' } 
		  , 'balise' => $params{ 'balise' }
		  ) ;
open ( RSA, ">$params{ 'fichier' }" ) ;

print RSA "#DEB:".$machine."\n" ;
print RSA "\@".$machine.$rsa ;
print RSA "#FIN:".$machine."\n" ;

close ( RSA ) ;



}




=pod

=back

=cut


eval(join '',<main::DATA>) || die $@ unless caller;
1;

__END__

#################### TESTS #########################
package IpsecSecretSphynx ;
#
use strict ;
#




