# -*- coding: iso-8859-1 -*-
"""
Srie de questions  poser au prompt
compatible avec une console python standard.
"""

import sys
import os
from os import system as run

from errors import *
from helpers import raw, lance_prompt, permissive_lance_prompt, select_list, \
     couples_list, dict_list, stringify

import entities

from contexte import Contexte
        
# instanciation
ctx = Contexte()

# mthodes d'appel du sphynx 

class Etab:
    """
    Questions concernant un tablissement
    """

    def quest_conn_add(self):
        """
        Questions concernant l'ajout d'une connexion ct etab

        """
        ordre = ['nom','left','leftnexthop','leftsubnet','leftsubnet_masque','left_nat']
        QUESTIONS = {
            'nom':"Saisissez le nom de la connexion",
            'left':"Saisissez l'adresse ip de l'interface externe de l'Amon (ou rien)" ,
            'leftnexthop':"Saisissez la valeur du routeur externe de l'etablissement (ou rien)",
            'leftsubnet':"Saisissez la valeur du subnet ct etablissement",
            'leftsubnet_masque':"Saisissez la valeur du masque du sous reseau de l'etablissement\n que vous voulez faire passer par le tunnel VPN",
            'left_nat':"Saisissez la valeur de l'adresse de translation pour le pare-feu",
            }
        return permissive_lance_prompt(QUESTIONS, ordre)
    

    def do_etab_connexion_add(self, id_etab):
        """
        Ajout d'une connexion cote etab
        @param id_etab: l'identifiant de l'tablissement
        """
        try:
            assert id_etab != "", "renseignez l'identifiant etablissement"
            quest_dict = self.quest_conn_add()
            # slection du reseau_sphynx
            print "Choix du reseau sphynx relie a la nouvelle connexion : "
            reseaux = ctx.sphynx.acad.get_reseaux()
            number = select_list(reseaux)
            # nom et identifiant du reseau choisi
            id_reseau = reseaux[number][0]
            nom = reseaux[number][1]
            print "Vous avez choisi le reseau %s (identifiant : %s) " % (nom, id_reseau)
            quest_dict['reseau'] = id_reseau

            # ajout effectif
            ctx.etab_connexion_add(id_etab, quest_dict)
        except Exception, e:
            print e.__class__, ":", e

    def do_etab_connexion_delete(self, id_etab):
        """
        Suppression d'une connexion
        @param id_etab: identifiant de l'etablissement
        """
        try:
            assert id_etab != "", "renseignez l'identifiant etablissement"
            # selection de la connexion
            etab = ctx.sphynx.get_etab(id_etab)
            connexions = etab.get_connexions()
            number = select_list(connexions)
            # nom et identifiant de la connexion choisie
            id_connexion = connexions[number][0]
            nom = connexions[number][1]
            # etab.del_connexion(id_connexion)
            # suppression effective
            ctx.etab_connexion_delete(id_etab, id_connexion)

        except Exception, e:
            print e.__class__, ":", e

        # sauvegarde des changements
        ctx.save()

    def do_etab_connexion_list(self, id_etab):
        """
        Liste des connexions d'un etab : renvoie les noms des connexions
        @param id_etab: l'identifiant de l'tablissement
        """
        try:
            assert id_etab != "", "renseignez l'identifiant etablissement"
            connexions = ctx.etab_connexion_list(id_etab)
            print couples_list(connexions)

        except Exception, e:
            print e.__class__, ':', e

# TODO
#     def do_etab_connexion_translation_list(self, args):
#         """
#         Liste des translations pour une connexion donne
#         @param : identifiant de l'etablissement 
#         """
#         pass

    def quest_translation_add(self):
        """
        Demande quelle connexion modifier (pour la suppression de translation)
        """
        ordre = ["source","destination"]
        QUESTIONS = {
            "source": "Saisissez la source de la translation" ,
            "destination": "Saisissez la destination de la translation" 
            }
        
        return lance_prompt(QUESTIONS, ordre)


    def do_etab_connexion_translation_add(self, id_etab):
        """
        Ajout d'une translation  une connexion etablissement
        @param : identifiant de l'tablissement
        """
        try:
            assert id_etab != "", "renseignez l'identifiant etablissement"
            # selection de la connexion
            print "-- selection de la connexion :"

            etab = ctx.sphynx.get_etab(id_etab)
            connexions = etab.get_connexions()
            number = select_list(connexions)
            # reconstruction  de l'indentifiant de la connexion
            id_connexion = connexions[number][0]
            nom = connexions[number][1]
            print "-- vous avez choisi la connexion %s " % nom.encode()
            # nous rcuprons le node connexion directement
            conn = etab.get_connexion(id_connexion)
            # questions
            trs_dict = self.quest_translation_add()
            # conn.add_translation(trs_dict['source'], trs_dict['destination'])
            ctx.etab_connexion_translation_add(id_etab, id_connexion, trs_dict)
        except Exception, e:
            print e.__class__, ":", e

    def do_etab_connexion_translation_list(self, id_etab):
        """
        Liste des translations d'une connexion d'un etablissement
        @param : identifiant de l'tablissement
        """
        try:
            assert id_etab != "", "renseignez l'identifiant etablissement"
            # selection de la connexion
            etab = ctx.sphynx.get_etab(id_etab)
            connexions = etab.get_connexions()
            number = select_list(connexions)
            # reconstruction  de l'identifiant de la connexion
            id_connexion = connexions[number][0]
            nom = connexions[number][1]
            print "-- liste des translations pour la connexion %s " % nom.encode()
            # nous rcuprons le node connexion directement
            # conn = etab.get_connexion(id_connexion)
            # affichage des translations
            # print dict_list(conn.translations)
            print dict_list(ctx.etab_connexion_translation_list(id_etab, id_connexion))

        except Exception, e:
            print e.__class__, ":", e

    def do_etab_connexion_translation_delete(self, id_etab):
        """
        Suppression d'une translation  une connexion etablissement
        @param : identifiant de l'tablissement
        """
        try:
            assert id_etab != "", "renseignez l'identifiant etablissement"
            # selection de la connexion
            print "-- selection de la connexion :"
            etab = ctx.sphynx.get_etab(id_etab)
            connexions = etab.get_connexions()
            number = select_list(connexions)
            # reconstruction  de l'indentifiant de la connexion
            id_connexion = connexions[number][0]
            nom = connexions[number][1]
            # 
            print "Vous avez choisi la connexion %s " % nom
            conn = etab.get_connexion(id_connexion)
            #
            print "-- selection de la translation : "
            translations = conn.get_translations()
            number = select_list(translations)
            trs_dict = translations[number]
            print "vous avez choisi la translation : " + stringify(trs_dict)
            # 
            # conn.del_translation(source=trs_dict['source'], destination=trs_dict['destination'])
            ctx.etab_connexion_translation_delete(id_etab, id_connexion, trs_dict)
            
        except Exception, e:
            print e.__class__, ":", e
            
        # sauvegarde des changements
        ctx.save()

class Acad:
    """
    Questions concernant le ct acadmique
    """

    def do_sphynx_reseau_add(self, args):
        """
        Ajout d'un reseau cote sphynx
        """
        try:
            quest_dict = self.quest_res_add()
            # ctx.sphynx_reseau_add(quest_dict)
            ctx.sphynx_reseau_add(quest_dict)

        except Exception, e:
            print e.__class__, ":", e

    def quest_res_add(self):
        """
        Questions concernant l'ajout d'un reseau ct sphynx
        """
        ordre = ['nom','right','rightnexthop','rightsubnet','rightsubnet_masque']
        QUESTIONS = {
            'nom':"Saisissez le nom du reseau cote sphynx",
            'right':"Saisissez l'adresse ip de l'interface externe du sphynx sinon rien",
            'rightnexthop':"Saisissez la valeur du routeur Externe ct sphynx sinon rien",
            'rightsubnet':"Saisissez la valeur du subnet ct sphynx",
            'rightsubnet_masque':"Saisissez la valeur du masque du subnet ct sphynx",
            }
        
        return permissive_lance_prompt(QUESTIONS, ordre)
    

    def do_sphynx_reseau_delete(self, args):
        """
        Suppression d'un reseau ct sphynx
        """
        try:
            # selection du rseau
            reseaux = ctx.sphynx.acad.get_reseaux()
            number = select_list(reseaux)
            # reconstruction  de l'indentifiant du rseau
            id_reseau = reseaux[number][0]
            nom = reseaux[number][1]
            # ctx.sphynx.acad.del_reseau(id_reseau)
            ctx.sphynx_reseau_delete(id_reseau)

        except Exception, e:
            print e.__class__, ":", e


    def do_sphynx_reseau_list(self, args):
        """
        Liste des reseaux cts academiques : renvoie les noms des rseaux
        """
        try:
            # reseaux = self.sphynx.acad.get_reseau_names()
            # reseaux = ctx.sphynx.acad.get_reseaux()
            print couples_list(ctx.sphynx_reseau_list())

        except Exception, e:
            print e.__class__, ':', e

        
class Sphynx(Acad, Etab):
    """
    Questions concernant le sphynx dans son ensemble
    """

    def reload(self):
        """
        Visiteur du contexte pour recharger le sphynx
        (en cas d'utilisation du sphynx d'origine)
        """
        ctx.reload()

    def do_sphynx_etab_list(self, args):
        """
        Liste des tablissements figurant dans le sphynx
        """
        print "\n".join(ctx.sphynx.get_etab_list())

    def __repr__(self):
        """
        Reprsentation _vide_ (compatibilit avec la Console python)
        """
        return ""
        
    def do_sphynx_init(self, args):
        """
        Initialisation du sphynx
        """
        identifiant = raw("Entrez l'identifiant du sphynx")
        response = raw("Voulez-vous lancer le sphynx en mode clef RSA ? (o/n)")
        if response in ["O","o","oui","OUI","Oui","yes", "y", "Yes"]:
            ctx.mode = "normal"
            # initialisation en mode clef
            self.taille = raw("Saisissez la taille de la clef")
            cmd = ctx.prepath + "-i -p -k %s -n %s" % (str(self.taille), str(identifiant))

        else:
            ctx.mode ="pki"
            # initialisation en mode certificat
            cmd = ctx.prepath + "-i -p -n %s" % identifiant

        run(cmd)

        # il faut crer l'objet sphynx
        try:
            # rglage pour les commandes du sphynx
            ctx.prepath = "cd .. ; ./sphynx "
            # si le sphynx n'est pas encore instanci
            if os.path.isfile("../xml/sphynx.xml"):
                ctx.sphynx = entities.Sphynx()

        except Exception, e:
            print e.__class__, ":", e
            sys.exit(1)

    def do_etab_creation(self, id_etab):
        """
        Cration d'un etablissement
        @param id_etab: l'identifiant de l'tablissement
        """
        # rne = raw("Entrez le numero d'etablissement (RNE)")
         
        try:
            assert id_etab != "", "renseignez l'identifiant etablissement"

            # il faut redemander la taille de la clef (elle n'est pas srialise)
            if ctx.mode == "normal":
                # mode clef
                self.taille = raw("Saisissez la taille de la clef")
                cmd = ctx.prepath + "-a -p -n %s -k %s" %(id_etab, self.taille)
            else:
                # mode certificat (normal)
                cmd = ctx.prepath + "-a -p -n %s" % id_etab

            run(cmd)
            self.reload()

        except Exception, e:
            print e.__class__, ":", e

    def do_etab_delete(self, id_etab):
        """
        Suppression d'un etablissement
        @param id_etab: l'identifiant de l'tablissement
        """
        try:
            assert id_etab != "", "renseignez l'identifiant etablissement"
            # rne = raw("Entrez le numero d'etablissement (RNE) a supprimer")
            cmd = ctx.prepath + "-s " + id_etab
            run(cmd)
            self.reload()
        except Exception, e:
            print e.__class__, ":", e
            
    def do_gen_conf_etablissement(self, id_etab):
        """
        Generation de la conf d'un etablissement
        @param id_etab: l'identifiant de l'tablissement
        """
        try:
            # rne = raw("Entrez le numero d'etablissement (RNE)")
            assert id_etab != "", "renseignez l'identifiant etablissement"
            cmd = ctx.prepath + "-g " + id_etab
            run(cmd)
        except Exception, e:
            print e.__class__, ":", e
            
    def do_gen_conf_sphynx(self, args):
        """
        Generation de la conf sphynx totale
        """
        cmd = ctx.prepath + "-t"
        run(cmd)

    def do_gen_rapport(self, args):
        """
        Gnration d'un rapport sur le sphynx
        """
        cmd = ctx.prepath + "-r"
        run(cmd)

if __name__ == "__main__":
    pass
