# -*- coding: iso-8859-1 -*-
        

def doctest_acad_get_default():
    """
    >>> from tunnel.entities import *
    >>> s = Sphynx("sphynx.xml")
    >>> acad = s.acad
    >>> acad.default == {'rightsubnet': u'sdf/sdf', 'right': u'sdf', 'rightnexthop': u'sdf'}
    True
    >>>
    """

def doctest_acad_add_reseau_complet():
    """
    >>> from tunnel.entities import *
    >>> s = Sphynx("sphynx.xml")
    >>> acad = s.acad
    >>> len(acad.reseaux) == 2
    True
    >>> d = {"nom":"reseau_test", 'right':'dsfsd', 'rightsubnet':'dfdf','rightnexthop':'dfsdf'}
    >>> acad.add_reseau(d)
    >>> len(acad.reseaux) == 3
    True
    >>>
    """

def doctest_acad_add_reseau():
    """
    >>> from tunnel.entities import *
    >>> s = Sphynx("sphynx.xml")
    >>> acad = s.acad
    >>> len(acad.reseaux) == 2
    True
    >>> d = {"nom":"reseau_test"}
    >>> acad.add_reseau(d)
    >>> len(acad.reseaux) == 3
    True
    >>>
    """

def doctest_acad_add_minimal():
    """
    >>> from tunnel.entities import *
    >>> s = Sphynx("sphynx.xml")
    >>> acad = s.acad
    >>> len(acad.reseaux) == 2
    True
    >>> d = {}
    >>> acad.add_reseau(d)
    >>> len(acad.reseaux) == 3
    True
    >>>
    """

def doctest_acad_del_reseau():
    """
    >>> from tunnel.entities import *
    >>> s = Sphynx("sphynx.xml")
    >>> acad = s.acad
    >>> len(acad.reseaux) == 2
    True
    >>> d = {"nom":"reseau_test"}
    >>> acad.add_reseau(d)
    >>> len(acad.reseaux) == 3
    True
    >>> reseau = acad.reseaux[0]
    >>> acad.del_reseau("sphynx-2")
    >>> len(acad.reseaux) == 2
    True
    """

def doctest_del_default_reseau():
    """
    >>> from tunnel.entities import *
    >>> from tunnel.errors import *
    >>> s = Sphynx("sphynx.xml")
    >>> acad = s.acad
    >>> len(acad.reseaux) == 2
    True
    >>> try:
    ...   acad.del_reseau("sphynx-0")
    ... except ReseauSphynxError, e:
    ...   print e.__class__
    ...
    tunnel.errors.ReseauSphynxError
    """
      
def test_suite():
    import sys
    import doctest  
    return doctest.DocTestSuite(sys.modules[__name__])

if __name__ == "__main__":
    import unittest
    unittest.main(defaultTest='test_suite')
