<?xml version="1.0" encoding="ISO-8859-1" ?>

<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>
<xsl:output encoding="UTF-8" omit-xml-declaration="yes" indent="no" method="text"  />
<!--
#    Conception :
#    Eole (http://eole.orion.education.fr)

#    Copyright (C) 2002

#    Ce code a t dvelopp par
#    Gwenal Rmond (gwenael.remond@free.fr)
#    Samuel Morin (samuel.morin@ac-dijon.fr)

#    distribu sous la licence GPL-2 

#    Version $Revision: 1.11 $

#    En attendant une traduction officielle de la GPL, la notice de 
#    copyright demeure en anglais.

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#    $Id: ipsecConfEtabPKI.xsl,v 1.11 2005/01/14 14:34:36 eole Exp $
#    $Source: /home/cvs/sphynx/sphynx-vpn/xsl/ipsecConfEtabPKI.xsl,v $


#    Se reporter  la documentation envoye avec le programme pour la notice.
#    Si elle manquait, envoyer un email  Gwenal Rmond (gwenael.remond@free.fr)
#    Samuel Morin (samuel.morin@ac-dijon.fr)

-->
<!--

=pod

=head1 NOM


ipsecConfEtabPKI.xsl


=cut

-->

<!--

=pod

=head1 DESCRIPTION



Gnrateur de configuration ipsec Etablissement suivant le numro identifiant de ce dernier.



=cut

-->

<!--

=pod

=head1 SYNOPSIS



id : numro identifiant de l'tablissement  passer par paramtre.



=cut

-->



<!--

=pod

=head1 PARAMETRES GLOBAUX




=cut

-->

<!--

=pod

=over 

=cut

-->




<!--

=pod

=item I<$id>

numro identifiant de l'tablissement

=cut

-->
<xsl:param name="id" />




<!--

=pod

=back

=cut

-->






<xsl:strip-space elements="clef-publique"/>
<!--

=pod

=head1 TEMPLATES




=cut

-->

<!--

=pod

=over 

=cut

-->



<!--

=pod

=item I</>

Template racine

=cut

-->
<xsl:template match='/' >
    <xsl:apply-templates select="sphynx/academie"/>
    <xsl:apply-templates select='sphynx/etablissement[@id=$id]'/>

</xsl:template>

<!--

=pod

=item I<academie>

Utilisation des donnes acadmiques

=cut

-->
<xsl:template match='academie' >
	<xsl:text>version 2
config setup
        interfaces=%defaultroute
        klipsdebug=none
        plutodebug=none
	#strictcrlpolicy=yes
        uniqueids=yes
</xsl:text>
	<xsl:if test="/sphynx/etablissement[@id=$id]/connexion[1]/left_priv and normalize-space(/sphynx/etablissement[@id=$id]/connexion[1]/left_priv/text())!=''">
		<xsl:text>	nat_traversal=yes
		</xsl:text>
</xsl:if>
<xsl:text>&#xA;</xsl:text>
<xsl:text>conn %default
        keyingtries=3
        keylife=8h
        ikelifetime=3h
        authby=rsasig
        pfs=yes
</xsl:text>
<xsl:text>&#xA;</xsl:text>
#DEB: ca-<xsl:value-of select="/sphynx/@id"/>
ca ca-<xsl:value-of select="/sphynx/@id"/>
        cacert=CertifCa.pem
        <xsl:if test="crl/url_crl1">crluri=<xsl:value-of select="crl/url_crl1"/>
        </xsl:if>
	<xsl:if test="crl/url_crl2">
	crluri2=<xsl:value-of select="crl/url_crl2"/>
        </xsl:if>
	auto=add
#FIN: ca-<xsl:value-of select="/sphynx/@id"/>
<xsl:text>&#xA;</xsl:text>
</xsl:template>

<!--

=pod

=item I<etablissement>

Template tablissement (appel d'une connexion)

=cut

-->
<xsl:template match='etablissement' >
#DEB:<xsl:value-of select="@id"/>-<xsl:value-of select="/sphynx/@id"/>
    <xsl:apply-templates select='connexion'/>
#FIN:<xsl:value-of select="@id"/>-<xsl:value-of select="/sphynx/@id"/>
<xsl:text>&#xA;</xsl:text>
</xsl:template>

<!--

=pod

=item I<connexion>

Gnration d'une conf de connexion

=cut

-->
<xsl:template match='connexion' >
<xsl:variable name= "reseau" select="@reseau"/>
<xsl:text>&#xA;</xsl:text>
conn C-<xsl:value-of select="@id"/>-<xsl:value-of select="/sphynx/@id"/>
        rightrsasigkey=%cert
        leftrsasigkey=%cert
        rightid="@<xsl:value-of select="/sphynx/@nom"/>"
	<xsl:choose>
<xsl:when test="/sphynx/academie/reseau_sphynx[@id=$reseau]/right_redondee/text() and normalize-space(/sphynx/academie/reseau_sphynx[@id=$reseau]/right_redondee/text())!=''">
<xsl:text>
	right=</xsl:text><xsl:value-of select="/sphynx/academie/reseau_sphynx[@id=$reseau]/right_redondee"/>
</xsl:when>
<xsl:otherwise>
<xsl:text>
	right=</xsl:text><xsl:value-of select="/sphynx/academie/reseau_sphynx[@id=$reseau]/right"/>
</xsl:otherwise>
	</xsl:choose>
	rightsubnet=<xsl:value-of select="/sphynx/academie/reseau_sphynx[@id=$reseau]/rightsubnet"/>
        rightnexthop=<xsl:value-of select="/sphynx/academie/reseau_sphynx[@id=$reseau]/rightnexthop"/>
        leftid="@<xsl:value-of select="../@machine" />"
        <xsl:choose>
<xsl:when test="../connexion[1]/left_priv and normalize-space(../connexion[1]/left_priv/text())!=''">
<xsl:text>left=</xsl:text><xsl:value-of select="../connexion[1]/left_priv"/>
</xsl:when>
<xsl:otherwise>
<xsl:text>left=</xsl:text><xsl:value-of select="left"/>
</xsl:otherwise>
        </xsl:choose>
	leftcert=/etc/freeswan/ipsec.d/<xsl:value-of select="../@id"/>.pem<xsl:if test="left/@nat">
<xsl:text>&#xA;        leftsourceip=</xsl:text><xsl:value-of select="left/@nat"/></xsl:if><xsl:if test="leftsubnet">
<xsl:text>&#xA;        leftsubnet=</xsl:text><xsl:value-of select="leftsubnet"/></xsl:if>
        <xsl:choose>
<xsl:when test="../connexion[1]/leftnexthop_priv and normalize-space(../connexion[1]/leftnexthop_priv/text())!=''">
<xsl:text>&#xA;        leftnexthop=</xsl:text><xsl:value-of select="../connexion[1]/leftnexthop_priv"/>
</xsl:when>
<xsl:otherwise>
<xsl:text>&#xA;        leftnexthop=</xsl:text><xsl:value-of select="leftnexthop"/>
</xsl:otherwise>
        </xsl:choose>
        leftupdown="/etc/freeswan/ipsec_updown_<xsl:value-of select='/sphynx/@id'/>-<xsl:value-of select='@id'/>"
	lefthostaccess=yes
	ike=aes256-sha2_512-modp8192,aes128-sha2_256-modp2048,aes128-sha-modp2048,aes128-sha2_256-modp1536,aes128-sha-modp1536,3des-md5-modp1536,3des-md5-modp1024,3des-sha-modp1536,3des-sha-modp1024
	esp=aes256-sha2_512,aes128-sha2_256,aes128-sha1,3des-md5,3des-sha1
	pfsgroup=modp2048
        auto=start
</xsl:template>


<!--

=pod

=back

=cut

-->



<!--

=pod

=head1 VOIR AUSSI


Pour toute information complmentaire, veuillez vous rendre
sur le site du Projet Sphinx  l'adresse suivante : 

TODO 

Reportez-vous aussi s'il vous plat au site gnrique du projet Eole :

http://eole.orion.education.fr



=cut

-->



</xsl:stylesheet>
