<?xml version="1.0" encoding="ISO-8859-1" ?>

<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>
<xsl:output encoding="UTF-8" omit-xml-declaration="yes" indent="no" method="text"  />
<!--
#    Conception :
#    Eole (http://eole.orion.education.fr)

#    Copyright (C) 2002

#    Ce code a t dvelopp par
#    Gwenal Rmond (gwenael.remond@free.fr)
#    Samuel Morin (samuel.morin@ac-dijon.fr)

#    distribu sous la licence GPL-2 

#    Version $Revision: 1.7 $

#    En attendant une traduction officielle de la GPL, la notice de 
#    copyright demeure en anglais.

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#    $Id: ipsecConfSphinxPKI.xsl,v 1.7 2005/01/12 08:21:00 eole Exp $
#    $Source: /home/cvs/sphynx/sphynx-vpn/xsl/ipsecConfSphinxPKI.xsl,v $


#    Se reporter  la documentation envoye avec le programme pour la notice.
#    Si elle manquait, envoyer un email  Gwenal Rmond (gwenael.remond@free.fr)
#    Samuel Morin (samuel.morin@ac-dijon.fr)

-->
<!--

=pod

=head1 NOM


ipsecConfSphinx.xsl


=cut

-->

<!--

=pod

=head1 DESCRIPTION



Gnrateur de configuration ipsec Sphinx (ct serveur sphynx)



=cut

-->

<!--

=pod

=head1 SYNOPSIS



TODO



=cut

-->








<xsl:strip-space elements="clef-publique"/>
<!--

=pod

=head1 TEMPLATES




=cut

-->

<!--

=pod

=over 

=cut

-->



<!--

=pod

=item I</>

Template racine

=cut

-->
<xsl:template match='/' >

    <xsl:apply-templates select="sphynx/academie"/>
    <xsl:apply-templates select='sphynx/etablissement'/>


</xsl:template>

<!--

=pod

=item I<academie>

Gnrateur de la conf acadmique

=cut

-->
<xsl:template match='academie' >

	<xsl:text>version 2
config setup
        interfaces=%defaultroute
        klipsdebug=none
        plutodebug=none
        uniqueids=yes
        strictcrlpolicy=no
        crlcheckinterval=600
        cachecrls=yes
        nat_traversal=yes

conn %default
        keyingtries=3
        keylife=8h
	ikelifetime=3h
        authby=rsasig</xsl:text>
        rightid="@<xsl:value-of select="/sphynx/@nom"/>"
        right=<xsl:value-of select="/sphynx/academie/reseau_sphynx[@id='sphynx-0']/right"/>
        rightrsasigkey=%cert
        leftrsasigkey=%cert
	rightcert=/etc/freeswan/ipsec.d/certs/sphynx.pem
        rightnexthop=<xsl:value-of select="/sphynx/academie/reseau_sphynx[@id='sphynx-0']/rightnexthop"/>
        pfs=yes
	ike=aes256-sha2_512-modp8192,aes256-sha2_256-modp8192,aes128-sha2_256-modp2048,aes128-sha-modp2048,aes128-sha2_256-modp1536,aes128-sha-modp1536,3des-md5-modp1536,3des-md5-modp1024,3des-sha-modp1536,3des-sha-modp1024
	esp=aes256-sha2_512,aes256-sha2_256,aes128-sha2_256,aes128-sha1,3des-md5,3des-sha1
        pfsgroup=modp2048

ca ca-sphynx
	cacert=CertifCa.pem
	<xsl:if test="crl/url_crl1">crluri=<xsl:value-of select="crl/url_crl1"/>
	</xsl:if>
	<xsl:if test="crl/url_crl2">
	crluri2=<xsl:value-of select="crl/url_crl2"/>
	</xsl:if>
	auto=add
</xsl:template>

<!--

=pod

=item I<etablissement>

Template tablissement (appel d'une connexion)

=cut

-->
<xsl:template match='etablissement' >
    <xsl:apply-templates select='connexion'/>

</xsl:template>

<!--

=pod

=item I<connexion>

Gnration d'une conf de connexion

=cut

-->
<xsl:template match='connexion' >
<xsl:variable name= "reseau" select="@reseau"/>
<xsl:text>&#xA;</xsl:text>
#DEB:<xsl:value-of select="@id"/>
# configuration de connexion pour <xsl:value-of select="@nom"/>
conn C-<xsl:value-of select="@id"/>-sphynx      
        leftid="@<xsl:value-of select="../@machine" />"
        left=<xsl:value-of select="left"/>
        <xsl:if test="leftsubnet">
        leftsubnet=<xsl:value-of select="leftsubnet"/>        
        </xsl:if>
        leftnexthop=<xsl:value-of select="leftnexthop"/>
        rightsubnet=<xsl:value-of select="/sphynx/academie/reseau_sphynx[@id=$reseau]/rightsubnet"/>
        auto=add
#FIN:<xsl:value-of select="@id"/>
<xsl:text>&#xA;</xsl:text>
</xsl:template>




<!--

=pod

=back

=cut

-->




<!--

=pod

=head1 NOTES



Conf  Tester.



=cut

-->



<!--

=pod

=head1 TODO



Rcupration de l'identifiant de l'tablissement  traiter.



=cut

-->


<!--

=pod

=head1 VOIR AUSSI


Pour toute information complmentaire, veuillez vous rendre
sur le site du Projet Sphinx  l'adresse suivante : 

TODO 

Reportez-vous aussi s'il vous plat au site gnrique du projet Eole :

http://eole.orion.education.fr



=cut

-->



</xsl:stylesheet>
