<?xml version="1.0" encoding="ISO-8859-1" ?>

<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>
<xsl:output encoding="UTF-8" omit-xml-declaration="yes" indent="no" method="text"  />
<!--
#    Conception :
#    Eole (http://eole.orion.education.fr)

#    Copyright (C) 2002

#    Ce code a t dvelopp par
#    Gwenal Rmond (gwenael.remond@free.fr)
#    Samuel Morin (samuel.morin@ac-dijon.fr)

#    distribu sous la licence GPL-2 

#    Version $Revision: 1.5 $

#    En attendant une traduction officielle de la GPL, la notice de 
#    copyright demeure en anglais.

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#    $Id: ipsecConfUpdownEtab.xsl,v 1.5 2005/01/11 13:04:56 eole Exp $
#    $Source: /home/cvs/sphynx/sphynx-vpn/xsl/ipsecConfUpdownEtab.xsl,v $


#    Se reporter  la documentation envoye avec le programme pour la notice.
#    Si elle manquait, envoyer un email  Gwenal Rmond (gwenael.remond@free.fr)
#    Samuel Morin (samuel.morin@ac-dijon.fr)

-->
<!--

=pod

=head1 NOM


ipsecCondUpdownEtab.xsl


=cut

-->

<!--

=pod

=head1 DESCRIPTION



Gnrateur de configuration ipsec pour l'iptables dynamique ct
tablissement.
id : numro identifiant de l'tablissement  passer par paramtre.



=cut

-->

<!--

=pod

=head1 SYNOPSIS



xsltproc ipsecConfUpdownEtab.xsl sphynx.xml > ipsec_updown_sphynx_[id]



=cut

-->



<!--

=pod

=head1 PARAMETRES GLOBAUX




=cut

-->

<!--

=pod

=over 

=cut

-->




<!--

=pod

=item I<$id>

numro identifiant de l'tablissement

=cut

-->
<xsl:param name="id" />




<!--

=pod

=back

=cut

-->






<!--

=pod

=head1 TEMPLATES




=cut

-->

<!--

=pod

=over 

=cut

-->



<!--

=pod

=item I</>

Template racine

=cut

-->
<xsl:template match='/' >
 <xsl:apply-templates select="sphynx/academie"/>
 <xsl:apply-templates select='sphynx/etablissement[@id=$id]'/>
</xsl:template>

<!--

=pod

=item I<academie>

Template vide : les donnes acadmiques ne sont pas utilises ici.

=cut

-->
<xsl:template match='academie' >
<!-- ne fait rien -->

</xsl:template>


<xsl:template match='etablissement' >
<!-- rajout du template etablissement car c'est  la connexion que les -->
<!-- pages sont crees -->
<xsl:apply-templates select="connexion"/>
</xsl:template>


<!--

=pod

=item I<etablissement>

guide pour lancer le template connexion

=cut

-->
<xsl:template match='connexion' >
<xsl:document href="{concat('/usr/share/eole/sphynx-vpn/ipsec/ipsec_updown_',/sphynx/@id,'-',@id)}"
		method="text"
		indent="no"
		encoding="ISO-8859-1"
		omit-xml-declaration="yes">
<xsl:text><![CDATA[#! /bin/sh
# Copyright (C) 2000, 2001  D. Hugh Redelmeier, Henry Spencer
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# RCSID $Id: ipsecConfUpdownEtab.xsl,v 1.5 2005/01/11 13:04:56 eole Exp $



# CAUTION:  Installing a new version of FreeS/WAN will install a new
# copy of this script, wiping out any custom changes you make.  If
# you need changes, make a copy of this under another name, and customize
# that, and use the (left/right)updown parameters in ipsec.conf to make
# FreeS/WAN use yours instead of this default one.


# check interface version
case "$PLUTO_VERSION" in
1.[0])	# Older Pluto?!?  Play it safe, script may be using new features.
	echo "$0: obsolete interface version \`$PLUTO_VERSION'," >&2
	echo "$0: 	called by obsolete Pluto?" >&2
	exit 2
	;;
1.*)	;;
*)	echo "$0: unknown interface version \`$PLUTO_VERSION'" >&2
	exit 2
	;;
esac

# check parameter(s)
case "$*" in
'')	;;
ipfwadm)	# caused by (left/right)firewall=yes; for default script only
	;;
*)	echo "$0: unknown parameter \`$1'" >&2
	exit 2
	;;
esac

# utility functions for route manipulation
# Meddling with this stuff should not be necessary and requires great care.
uproute() {
	doroute add
}
downroute() {
	doroute del
}
doroute() {
	parms="-net $PLUTO_PEER_CLIENT_NET netmask $PLUTO_PEER_CLIENT_MASK"
	parms="$parms dev $PLUTO_INTERFACE gw $PLUTO_NEXT_HOP"
	route $1 $parms
	st=$?
	if test $st -ne 0
	then
		# route has already given its own cryptic message
		echo "$0: \`route $1 $parms' failed" >&2
	fi
	return $st
}



# the big choice
case "$PLUTO_VERB:$1" in
prepare-host:*|prepare-client:*)
	# delete possibly-existing route (preliminary to adding a route)
	parms="-net $PLUTO_PEER_CLIENT_NET netmask $PLUTO_PEER_CLIENT_MASK"
	oops="`route del $parms 2>&1`"
	status="$?"
	if test " $oops" = " " -a " $status" != " 0"
	then
		oops="silent error, exit status $status"
	fi
	case "$oops" in
	'SIOCDELRT: No such process')
		# This is what route (currently -- not documented!) gives
		# for "could not find such a route".
		oops=
		status=0
		;;
	esac
	if test " $oops" != " " -o " $status" != " 0"
	then
		echo "$0: \`route del $parms' failed ($oops)" >&2
	fi
	exit $status
	;;
route-host:*|route-client:*)
	# connection to me or my client subnet being routed
	uproute
	;;
unroute-host:*|unroute-client:*)
	# connection to me or my client subnet being unrouted
	downroute
	;;
up-host:*)
	# connection to me coming up
	# If you are doing a custom version, firewall commands go here.
	;;
down-host:*)
	# connection to me going down
	# If you are doing a custom version, firewall commands go here.
	;;
up-client:)
]]></xsl:text>
<xsl:call-template name="insertion">
<xsl:with-param name='reseau' select="@reseau"/>
</xsl:call-template>
<xsl:text><![CDATA[
	/sbin/iptables -I FORWARD -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK -o ipsec0 -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -j ACCEPT
	/sbin/iptables -I FORWARD -i ipsec0 -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK -j ACCEPT
	/sbin/iptables -I FORWARD -m state --state ESTABLISHED,RELATED -j ACCEPT
	/sbin/iptables -I INPUT -m state --state ESTABLISHED,RELATED -i ipsec0 -j ACCEPT
	;;
down-client:)
]]></xsl:text>
<xsl:call-template name="suppression">
<xsl:with-param name='reseau' select="@reseau"/>
</xsl:call-template>
<xsl:text><![CDATA[
	#on autorise les reseaux aux deux extremites du tunnel a echanger
	/sbin/iptables -D FORWARD -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK -o ipsec0 -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -j ACCEPT
	/sbin/iptables -D FORWARD -i ipsec0 -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK -j ACCEPT
	/sbin/iptables -D FORWARD -m state --state ESTABLISHED,RELATED -j ACCEPT
	/sbin/iptables -D INPUT -m state --state ESTABLISHED,RELATED -i ipsec0 -j ACCEPT
	;;
*)	echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
	exit 1
	;;
esac
]]>
</xsl:text>

</xsl:document>
</xsl:template>

<!--

=pod

=item I<connexion>

gnration de rgle iptables

=cut

-->
<xsl:template name="suppression">
<xsl:param name="reseau"/>
<xsl:choose>
<xsl:when test="../connexion[1]/left_priv and normalize-space(../connexion[1]/left_priv/text())!=''">
<xsl:if test="left/@nat">
<xsl:text>
/sbin/iptables -t nat -D POSTROUTING -s </xsl:text><xsl:value-of select="../connexion[1]/left_priv"/><xsl:text> -o ipsec0 -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -j SNAT --to </xsl:text><xsl:value-of select="left/@nat"/>
<xsl:text>&#xA;</xsl:text>
</xsl:if>
</xsl:when>
<xsl:otherwise>
<xsl:if test="left/@nat">
<xsl:text>
/sbin/iptables -t nat -D POSTROUTING -s </xsl:text><xsl:value-of select="left"/><xsl:text> -o ipsec0 -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -j SNAT --to </xsl:text><xsl:value-of select="left/@nat"/>
<xsl:text>&#xA;</xsl:text>
</xsl:if>
</xsl:otherwise>
</xsl:choose>
<xsl:apply-templates select="translation" mode="suppression"/>
</xsl:template>

<!--

=pod

=item I<translation>

generation rgle iptables

=cut

-->
<xsl:template match='translation' mode="suppression">
<xsl:text>
/sbin/iptables -t nat -D POSTROUTING -s </xsl:text>
<xsl:value-of select="@source"/>
<xsl:text> -o ipsec0 </xsl:text>
<xsl:text> -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -j SNAT</xsl:text>
<xsl:text> --to </xsl:text><xsl:value-of select="@destination"/> 
<xsl:text> &#xA;</xsl:text>
<xsl:text>#on autorise les differents reseau a utiliser le tunnel
/sbin/iptables -D FORWARD -s </xsl:text>
<xsl:value-of select="@source"/>
<xsl:text> -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK</xsl:text>
<xsl:text> -o ipsec0 -j ACCEPT </xsl:text>
<xsl:text>&#xA;</xsl:text>

</xsl:template>

<!--

=pod

=item I<connexion>

gnration de rgle iptables

=cut

-->
<xsl:template name="insertion">
<xsl:param name="reseau"/>
## Ajout des regles dynamiques lorsque le tunnel monte...
<xsl:choose>
<xsl:when test="../connexion[1]/left_priv and normalize-space(../connexion[1]/left_priv/text())!=''">
<xsl:if test="left/@nat">
<xsl:text>
/sbin/iptables -t nat -I POSTROUTING -s </xsl:text><xsl:value-of select="../connexion[1]/left_priv"/><xsl:text> -o ipsec0 -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -j SNAT --to </xsl:text><xsl:value-of select="left/@nat"/>
</xsl:if>
</xsl:when>
<xsl:otherwise>
<xsl:if test="left/@nat">
<xsl:text>
/sbin/iptables -t nat -I POSTROUTING -s </xsl:text><xsl:value-of select="left"/><xsl:text> -o ipsec0 -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -j SNAT --to </xsl:text><xsl:value-of select="left/@nat"/>
</xsl:if>
</xsl:otherwise>
</xsl:choose>
<xsl:text>&#xA;</xsl:text>
<xsl:apply-templates select="translation" mode="insertion"/>
</xsl:template>

<!--

=pod

=item I<translation>

generation rgle iptables

=cut

-->
<xsl:template match='translation' mode="insertion">
<xsl:text>
/sbin/iptables -t nat -I POSTROUTING -s </xsl:text>
<xsl:value-of select="@source"/>
<xsl:text> -o ipsec0 </xsl:text>
<xsl:text> -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK -j SNAT</xsl:text>
<xsl:text> --to </xsl:text><xsl:value-of select="@destination"/> 
<xsl:text> &#xA;</xsl:text>
<xsl:text>
/sbin/iptables -I FORWARD -s </xsl:text>
<xsl:value-of select="@source"/>
<xsl:text> -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK</xsl:text>
<xsl:text> -o ipsec0 -j ACCEPT </xsl:text>
<xsl:text>&#xA;</xsl:text>

</xsl:template>




<!--

=pod

=back

=cut

-->



<!--

=pod

=head1 VOIR AUSSI


Pour toute information complmentaire, veuillez vous rendre
sur le site du Projet Sphinx  l'adresse suivante : 

TODO 

Reportez-vous aussi s'il vous plat au site gnrique du projet Eole :

http://eole.orion.education.fr



=cut

-->



</xsl:stylesheet>
